"use strict";

var nedbDatastore = require('nedb');

var config = {};
config.databases = {};

config.createDatabase = function () {
  var _this = this;

  return new Promise(function (resolve, reject) {
    config.databases[_this.name] = new nedbDatastore({
      filename: _this.name,
      timestampData: _this.timestampData,
      autoload: _this.autoload,
      done: _this.done,
      onload: _this.onload,
      afterSerialization: _this.afterSerialization,
      beforeDeserialization: _this.beforeDeserialization,
      corruptAlertThreshold: _this.corruptAlertThreshold,
      compareStrings: _this.compareStrings
    });

    if (_this.autoload) {
      config.databases[_this.name].loadDatabase();
    }

    resolve();
  });
};

config.loadDatabase = function () {
  var _this2 = this;

  return new Promise(function (resolve) {
    config.databases[_this2.name].loadDatabase();

    resolve();
  });
};

module.exports = config;