const nedbDatastore = require('nedb')

const config = {}

config.databases = {}

config.createDatabase = function () {
    return new Promise((resolve, reject) => {
        config.databases[this.name] = new nedbDatastore({
            filename: this.name, 
            timestampData: this.timestampData,
            autoload: this.autoload,
            done: this.done,
            onload: this.onload,
            afterSerialization: this.afterSerialization,
            beforeDeserialization: this.beforeDeserialization,
            corruptAlertThreshold : this.corruptAlertThreshold, 
            compareStrings: this.compareStrings 
        })
        
        if(this.autoload) {
            config.databases[this.name].loadDatabase()
        }

        resolve()
    })
}

config.loadDatabase = function () {
    return new Promise((resolve) => {
        config.databases[this.name].loadDatabase()
        resolve()
    })
}

module.exports = config